clear, close, clc;

px = 0.2:0.1:0.4; % Probability of input to be 1
p1 = 0:0.1:1;
p2 = p1/25;

for i = 1:length(px),
    SER = (p1 * px(i)) + (p2 * (1 - px(i)));
    CER2(i,:) = 1 - ((ones(size(SER)) - SER).^2);
    CER8(i,:) = 1 - ((ones(size(SER)) - SER).^8);
    CER24(i,:) = 1 - ((ones(size(SER)) - SER).^24);
end

plot(p1, CER2,'-o', p1, CER8,'-.*', p1, CER24,'--d', 'linewidth',2),

legend('NME 2 bits,  p_1=0.2','NME 2 bits,  p_1=0.3','NME 2 bits,  p_1=0.4', ...
       'NME 8 bits,  p_1=0.2','NME 8 bits,  p_1=0.3','NME 8 bits,  p_1=0.4', ...
       'NME 24 bits,  p_1=0.2','NME 24 bits,  p_1=0.3','NME 24 bits,  p_1=0.4'),
xlabel('Probability of receiving 0 when transmitting 1 (p_1)'),
ylabel('Codeword Error Rate (CER)'), grid

% set(gca, 'Position', get(gca, 'OuterPosition') - ...
%     get(gca, 'TightInset') * [-1 0 1 0; 0 -1 0 1; 0 0 1 0; 0 0 0 1]);
% 
% set(gcf, 'PaperUnits', 'inches');
% set(gcf, 'PaperSize', [6.6 4.1]);
% set(gcf, 'PaperPositionMode', 'manual');
% set(gcf, 'PaperPosition', [0 0 6.6 4.1]);
% 
% set(gcf, 'renderer', 'painters');
% 
% print(gcf, '-dpdf', 'perf-random.pdf');