clear, close, clc;
% Programmer   : Muhammad Agus Zainuddin
% Last editted : 22 Oct 2014
% Low Weight Coding with weight 2
%-----------   Input   ----------------
% Lena_gray.JPG
% AdobeUpdater.dll
% lena256.bmp
% news_cif.mp4
% BUSqcif7_5.yuv
% cancer256.bmp

fid=fopen('AdobeUpdater.dll','r'); % Open the file 
data = fread(fid)';             % Read data

% Count the number of "1"
data_bit = de2bi(data,8,'left-msb'); clear data;
binary_sequence = reshape(data_bit',1,size(data_bit,1) * size(data_bit,2));
clear data_bit;
Total_bits = length(binary_sequence);
Number_1_uncode = sum(binary_sequence);
%Percent_uncode = 100 * Number_1_uncode / Total_bits

% LWC(m,n,w). m = output size, n = input size, w = codeword weight. 
% LWC(8,4,2), LWC(16,6,2),LWC(24,8,2);
m = 20; % 
u = 2;
if m == 4,
    n = 2;
    load comb_4_2_2.mat;  % Codewords with weight 2 bits
    comb = s2(1:2^n);    % Only use first's 2^4 combinations
elseif m==8,
    n = 4;
    load comb_8_4_2.mat;  % Codewords with weight 2 bits
    comb = s2(1:2^n);    % Only use first's 2^4 combinations
elseif m == 12,
    n = 6;
    load comb_12_6_2.mat;  % Codewords with weight 2 bits
    comb = s2(1:2^n);    % Only use first's 2^6 combinations
elseif m == 16,
    n = 6;
    load comb_16_6_2.mat;  % Codewords with weight 2 bits
    comb = s2(1:2^n);    % Only use first's 2^6 combinations
elseif m == 20,
    n = 7;
    load comb_20_7_2.mat;  % Codewords with weight 2 bits
    comb = s2(1:2^n);    % Only use first's 2^8 combinations
end

% Coding table
tab = zeros(2^n,2);
for i = 1:2^n, 
    tab(i,:) = [i-1 comb(i)];
end

LWC_sym = de2bi(comb,m,'left-msb');
disp('--- Encoding Process ---'),
tic
binary_nbits = buffer(binary_sequence,n)';
%clear binary_sequence;
symbol_nbits = bi2de(binary_nbits,'left-msb')';
clear binary_nbits;
binary_mbits = zeros(length(symbol_nbits),m);
for i = 1:length(symbol_nbits),
    ind = find(symbol_nbits(i) == tab(:,1));    %ind2 indeks coding
    binary_mbits(i,:) = LWC_sym(ind,:);
end
toc
Number_1_LWC = sum(sum(binary_mbits))
Effisiensi = 100 * (Number_1_uncode - Number_1_LWC) / Number_1_uncode
% Count the number of sequential 1
Trans_Bits = reshape(binary_mbits',1,size(binary_mbits,1)*size(binary_mbits,2));
num11 = 0;
for i = 1:length(Trans_Bits)-1,
    if (Trans_Bits(i)==1) && (Trans_Bits(i+1)==1),
        num11 = num11+1;
    end
end
sequential_1 = num11
clear Trans_Bits; clear num11;
Bandwidth_expansion = m / n
p1 = 100 * u / m

disp('--- Decoding Process ---');
% --- Estimate the transmitted symbols ---
tic
LWC_sym_est = bi2de(binary_mbits,'left-msb')'; %clear binary_mbits;
% symbols_est = zeros(size(symbol_nbits)); %clear symbol_nbits;
symbols_est = zeros(size(LWC_sym_est)); %clear symbol_nbits;
for i = 1:length(LWC_sym_est),
    ind = find(LWC_sym_est(i) == tab(:,2));
    symbols_est(i) = tab(ind,1);
end
clear LWC_sym_est;
%Distortion = sum(symbol_nbits - symbol_est)

% --- Estimate the transmitted data ---
binary_nbits_est = de2bi(symbols_est,n,'left-msb');
binary_sequence_est = reshape(binary_nbits_est',1, ...
    size(binary_nbits_est,1) * size(binary_nbits_est,2));
clear binary_nbits_est;
data_sequence_est = binary_sequence_est(1:Total_bits);
clear binary_sequence_est;
toc
BER = sum(data_sequence_est - binary_sequence)/Total_bits
