clear, close, clc;
% Programmer   : Muhammad Agus Zainuddin
% Last editted : 25 September 2014
% Minimum Transmission Energy (MTE) Coding

% MTE (m,n)
%-----------   Input   ----------------
% Lena_gray.JPG
% AdobeUpdater.dll
% lena256.bmp
% news_cif.mp4
% BUSqcif7_5.yuv
% cancer256.bmp
% blood1.tif
fid=fopen('AdobeUpdater.dll','r'); 
data = fread(fid)';

% Count the number of "1"
data_bit = de2bi(data,8,'left-msb'); clear data;
Total_bits = size(data_bit,1) * size(data_bit,2);
binary_sequence = reshape(data_bit',1,Total_bits);  % Binary stream
clear data_bit;
Number_1_uncode = sum(binary_sequence);
%Percent_uncode = 100 * Number_1_uncode / Total_bits

% ME2(8,3), ME2(16,4), ME2(24,4)
m = 20; % output length / codeword (bits) 
if m == 4,
    n = 2;
elseif (m == 8) || (m==12),
    n = 3;
elseif (m == 16) || (m == 20),
    n = 4;
end
% Createt the table coding
tab = zeros(2^n,2);
for i = 2:(2^n), 
    tab(i,:) = [i-1 2^(i-2)];
end
tab

% Convert symbols to its binary representation.
comb = tab(:,2);    % Codewords
ME_sym = de2bi(comb,m,'left-msb');
% MTE (m,n)
disp('--- Encoding Process ---');
tic
binary_nbits = buffer(binary_sequence,n)';  % convert binary stream to n bits symbol.
% clear binary_sequence;
symbol_nbits = bi2de(binary_nbits,'left-msb')';
clear binary_nbits;
binary_mbits = zeros(length(symbol_nbits),m);
for i = 1:length(symbol_nbits),
    ind = find(symbol_nbits(i) == tab(:,1));    %ind2 indeks coding
    binary_mbits(i,:) = ME_sym(ind,:);
end
toc
clear symbol_nbits;

% Performance evalutions
Number_1_MEP = sum(sum(binary_mbits))
Effisiensi = 100 * (Number_1_uncode - Number_1_MEP) / Number_1_uncode
Transmitted_length = size(binary_mbits,1) * size(binary_mbits,2);
% Count consecutive 1
Trans_Bits = reshape(binary_mbits',1,size(binary_mbits,1)*size(binary_mbits,2));
num11 = 0;
for i = 1:length(Trans_Bits)-1,
    if (Trans_Bits(i)==1) && (Trans_Bits(i+1)==1),
        num11 = num11+1;
    end
end
sequential_1 = num11
clear Trans_Bits; clear num11;
bandwidth_expansion = Transmitted_length / Total_bits
p1 = 100 * Number_1_MEP / Transmitted_length % Probability bit 0

% Decoding Process
disp('--- Decoding ---');
tic
code_est = bi2de(binary_mbits,'left-msb')'; clear binary_mbits;
symbol_est = zeros(size(code_est));
for i = 1:length(code_est),
    ind = find(code_est(i) == tab(:,2));
    symbol_est(i) = tab(ind,1);
end
clear code_est;
binary_nbits_est = de2bi(symbol_est,n,'left-msb'); 
clear symbol_est;
binary_sequence_est = reshape(binary_nbits_est',1, ...
    size(binary_nbits_est,1) * size(binary_nbits_est,2));
clear binary_nbits_est;
data_sequence_est = binary_sequence_est(1:Total_bits);
clear binary_sequence_est;
toc
BER = sum(data_sequence_est - binary_sequence)/Total_bits